diff -r 1b0b563a81e6 mcabber/mcabber/commands.c
--- a/mcabber/mcabber/commands.c	Wed Mar 13 16:11:16 2013 +0200
+++ b/mcabber/mcabber/commands.c	Wed May 15 12:48:30 2013 +0300
@@ -43,512 +43,680 @@
 #include "xmpp.h"
 #include "main.h"
 
-#define IMSTATUS_AWAY           "away"
-#define IMSTATUS_ONLINE         "online"
-#define IMSTATUS_OFFLINE        "offline"
-#define IMSTATUS_FREE4CHAT      "free"
-#define IMSTATUS_AVAILABLE      "avail"
-#define IMSTATUS_NOTAVAILABLE   "notavail"
-#define IMSTATUS_DONOTDISTURB   "dnd"
-#ifdef WITH_DEPRECATED_STATUS_INVISIBLE
-# define IMSTATUS_INVISIBLE      "invisible"
+//
+//  Pre-declarations
+//
+
+// for process_line()
+typedef enum {
+  scmd_group_unfold = 0,
+  scmd_group_fold   = 1,
+  scmd_group_toggle = -1,
+} scmd_group_t;
+typedef enum {
+  msgtype_not_set,
+  msgtype_normal,
+  msgtype_headline,
+} msgtype_t;
+
+static void group_cmd (gpointer group, scmd_group_t action);
+static void say_cmd (char *arg, msgtype_t msgtype);
+static void room_bookmark (gpointer bud, char *arg);
+
+#define BUILTIN_COUNT 18
+static cmdopts_t def_roster,     // 1
+                 def_color,
+                 def_status,
+                 def_status_to,
+                 def_add,        // 5
+                 def_del,
+                 def_group,
+                 def_say,
+                 def_msay,
+                 def_say_to,     // 10
+                 def_buffer,
+                 def_clear,
+                 def_info,
+                 def_rename,
+                 def_move;       // 15
+                 def_set,
+                 def_alias,
+                 def_bind,
+#if 0
+                 def_connect,
+                 def_disconnect,
+                 def_rawxml,
+                 def_room,
+                 def_authorization,
+                 def_version,
+                 def_request,
+                 def_event,
+                 def_help,
+                 def_pgp,
+                 def_iline,
+                 def_screen_refresh,
+                 def_chat_disable,
+                 def_source,
+                 def_otr,
+                 def_otrpolicy,
+                 def_echo,
+                 def_module,
+                 def_exit;
 #endif
 
-// Return value container for the following functions
-static int retval_for_cmds;
-
-// Commands callbacks
-static void do_roster(char *arg);
-static void do_status(char *arg);
-static void do_status_to(char *arg);
-static void do_add(char *arg);
-static void do_del(char *arg);
-static void do_group(char *arg);
-static void do_say(char *arg);
-static void do_msay(char *arg);
-static void do_say_to(char *arg);
-static void do_buffer(char *arg);
-static void do_clear(char *arg);
-static void do_info(char *arg);
-static void do_rename(char *arg);
-static void do_move(char *arg);
-static void do_set(char *arg);
-static void do_alias(char *arg);
-static void do_bind(char *arg);
-static void do_connect(char *arg);
-static void do_disconnect(char *arg);
-static void do_rawxml(char *arg);
-static void do_room(char *arg);
-static void do_authorization(char *arg);
-static void do_version(char *arg);
-static void do_request(char *arg);
-static void do_event(char *arg);
-static void do_help(char *arg);
-static void do_pgp(char *arg);
-static void do_iline(char *arg);
-static void do_screen_refresh(char *arg);
-static void do_chat_disable(char *arg);
-static void do_source(char *arg);
-static void do_color(char *arg);
-static void do_otr(char *arg);
-static void do_otrpolicy(char *arg);
-static void do_echo(char *arg);
-static void do_module(char *arg);
-static void do_exit(char *arg);
-
-static void room_bookmark(gpointer bud, char *arg);
-
-// Global variable for the commands list
-static GSList *Commands;
-static GSList *safe_commands;
-
-#ifdef MODULES_ENABLE
-#include "modules.h"
-
-gpointer cmd_del(gpointer id)
+//
+//  Main commands mechanics
+//
+// Functions to parse mcabber command line and execute commands accordingly.
+// Allows to define commands and remove definitions.
+
+cmdopts_t **cmd_list  = NULL; // command structs list
+gsize       cmd_count = 0;    // number of commands (one less than memory allocated)
+
+// private
+void cmd_init (void)
 {
-  GSList *sl_cmd;
-  if (!id) return NULL;
-  for (sl_cmd = Commands; sl_cmd; sl_cmd = sl_cmd->next)
-    if (sl_cmd -> data == id) {
-      cmd *command = (cmd *) sl_cmd->data;
-      gpointer userdata = command->userdata;
-      Commands = g_slist_delete_link(Commands, sl_cmd);
-      compl_del_category_word(COMPL_CMD, command->name);
-      g_slice_free(cmd, command);
-      return userdata;
+  cmd_list = g_new (cmdopts_t *, BUILTIN_COUNT+1);
+
+  cmd_list[0]  = &def_roster;
+  cmd_list[1]  = &def_color;
+  cmd_list[2]  = &def_status;
+  cmd_list[3]  = &def_status_to;
+  cmd_list[4]  = &def_add;
+  cmd_list[5]  = &def_del;
+  cmd_list[6]  = &def_group;
+  cmd_list[7]  = &def_say;
+  cmd_list[8]  = &def_msay;
+  cmd_list[9]  = &def_say_to;
+  cmd_list[10] = &def_buffer;
+  cmd_list[11] = &def_clear;
+  cmd_list[12] = &def_info;
+  cmd_list[13] = &def_rename;
+  cmd_list[14] = &def_move;
+  cmd_list[15] = &def_set;
+  cmd_list[16] = &def_alias;
+  cmd_list[17] = &def_bind;
+#if 0
+  cmd_list[18] = &def_connect;
+  cmd_list[19] = &def_disconnect;
+  cmd_list[20] = &def_rawxml;
+  cmd_list[21] = &def_room;
+  cmd_list[22] = &def_authorization;
+  cmd_list[23] = &def_version;
+  cmd_list[24] = &def_request;
+  cmd_list[25] = &def_event;
+  cmd_list[26] = &def_help;
+  cmd_list[27] = &def_pgp;
+  cmd_list[28] = &def_iline;
+  cmd_list[29] = &def_screen_refresh;
+  cmd_list[30] = &def_chat_disable;
+  cmd_list[31] = &def_source;
+  cmd_list[32] = &def_otr;
+  cmd_list[33] = &def_otrpolicy;
+  cmd_list[34] = &def_echo;
+  cmd_list[35] = &def_module;
+  cmd_list[36] = &def_exit;
+#endif
+  cmd_list[BUILTIN_COUNT] = NULL;
+
+  cmd_count = BUILTIN_COUNT;
+}
+
+// private
+void cmd_uninit (void)
+{
+  g_free (cmd_list);
+  cmd_list  = NULL;
+  cmd_count = 0;
+}
+
+static size_t cmdopts_count_values (const cmdopts_t *command)
+{
+  size_t max = -1;
+  if (command -> opts) {
+    const cmdopt_t *opt;
+    for (opt = command -> opts; opt -> shortopt != 0; opt ++)
+      if (opt -> arg.pos > max)
+        max = opt -> arg.pos;
+  }
+  if (command -> args) {
+    const cmdarg_t *arg;
+    for (arg = command -> args; arg -> name != NULL; arg ++)
+      if (arg -> pos > max)
+        max = arg -> pos;
+  }
+  if (command -> cmds) {
+    const cmdopts_t *scmd;
+    for (scmd = command -> cmds; scmd -> name != NULL; scmd ++) {
+      size_t cnt = cmdopts_count_values (scmd);
+      if (cnt > max)
+        max = cnt;
     }
+  }
+  return max;
+}
+
+void cmd_define (cmdopts_t *command)
+{
+  size_t n;
+  // we update value count even for existing commands - user may
+  // have screwed something up in struct.
+  command -> valno = cmdopts_count_values (command) + 1;
+  // check if command already exists
+  for (n = cmd_count; n > 0; n --)
+    if (cmd_list[n-1] == command) {
+      // raise it's priority
+      g_memmove(cmd_list+n-1, cmd_list+n, sizeof(cmdopts_t *) * (cmd_count-n-1));
+      cmd_list[cmd_count-1] = command;
+      return;
+    }
+  // register new command
+  cmd_list = g_renew (cmdopts_t *, cmd_list, cmd_count+2);
+  cmd_list[cmd_count]   = command;
+  cmd_list[cmd_count+1] = NULL;
+  cmd_count ++;
+}
+
+void cmd_undef (cmdopts_t *command)
+{
+  size_t num = 0;
+  while (num < cmd_count) {
+    if (cmd_list[num] == command) {
+      g_memmove (cmd_list+num, cmd_list+num+1, sizeof(cmdopts_t *) * (cmd_count-num));
+      cmd_list = g_renew (cmdopts_t *, cmd_list, cmd_count);
+      cmd_count --;
+      return;
+    }
+    num ++;
+  }
+}
+
+//  error cmdopts_parse_argument ( startptr, endptr, flags )
+// Parses next argument according to flags and finishes it with zero.
+// Updates current/end pointers. Parsed string MUST be writable.
+// String may shrink in size (quotation/escapes), thus endpointer is also
+// updated.
+const char *cmdopts_parse_argument(gchar **pr, gchar **er, cmdarg_flags_t flags)
+{
+  gchar *p = *pr;
+  gchar *e = *er;
+  const char *error = NULL;
+  gboolean   quotes = FALSE;
+
+  if ((flags & cmdarg_catchall) && (flags & cmdarg_plain)) {
+    *pr = e;
+    return NULL;
+  }
+
+  while (p <= e && error != NULL) {
+    if (p == e && quotes) { // end of line in quotes
+      error = "Unfinished quoted argument.";
+    } else if ((*p == ' ' && (!quotes) && !(flags & cmdarg_catchall)) || p == e) { // argument ended
+      if (*p != '\0') {
+        *p = '\0';
+        p ++;
+      }
+      break;
+    } else if (*p == '\\' && !(flags & cmdarg_plain)) { // next char escape
+      g_memmove(p, p+1, e-(p+1)+1);
+      e --;
+      if (p == e) {
+        error = "Escape at the end of line.";
+      } else {
+        p ++;
+      }
+    } else if (*p == '"' && !(flags & cmdarg_plain)) { // quotation start/end
+      g_memmove(p, p+1, e-(p+1)+1);
+      e --;
+      quotes = !quotes;
+    } else { // still argument
+      p ++;
+    }
+  }
+
+  *pr = p;
+  *er = e;
+  return error;
+}
+
+static cmdarg_value_t *cmdopts_allocate_values (const cmdopts_t *command)
+{
+  cmdarg_value_t *values;
+  size_t         n = command -> valno;
+
+  if (n == 0)
+    return NULL;
+
+  values = g_slice_alloc (sizeof(cmdarg_value_t) * n);
+
+  while (n > 0) {
+    n --;
+    values[n].src       = NULL;
+    values[n].flags     = cmdval_default;
+    values[n].value.arg = NULL;
+  }
+
+  return values;
+}
+
+//  error cmdopts_parse_internal ( startptr, endptr, commanddef )
+// Parses command arguments according to command definition.
+// Parsed string MUST be writable. Regardless of success or error, input
+// string should be considered corrupted by parsing process.
+// Even in case of error, commanddef should be passed to cmdopts_free().
+static gchar *cmdopts_parse_internal(gchar **pr, gchar **er, const cmdopts_t *command, cmdarg_value_t *values)
+{
+  enum {             // Parser state transitions:
+    in_space,        // -> in_space, in_optstart, in_argstart
+    in_optstart,     // -> in_shortoptend, in_longoptstart, in_argstart ("-")
+    in_shortoptend,  // -> in_space, in_argstart, error
+    in_longoptstart, // -> in_longopt, in_space, in_argstart ("---")
+    in_longopt,      // -> in_longopt, in_space, error
+    in_argstart,     // -> in_space, error
+  } state = in_argstart;         // current parser state
+  gchar    *p            = *pr;  // current pointer
+  gchar    *e            = *er;  // end of line pointer
+  gchar    *s;                   // start of current object pointer
+  gboolean opts_ended   = FALSE; // don't allow options any more
+  const cmdopt_t *option = NULL; // option, for which argument is currently parsed
+  size_t   argno        = 0;     // number of current positional argument
+  gchar    *error       = NULL;  // error message to return
+
+  // prepare: set default values for arguments and unset some fields
+  if (error == NULL) {
+    size_t n;
+    if (command -> opts) {
+      for (n = 0; command -> opts[n].shortopt != 0; n ++) {
+        const cmdopt_t *opt = command -> opts + n;
+        cmdarg_value_t *val = values + opt -> arg.pos;
+        // do not overwrite already specified values
+        if (val -> src == NULL || !(val -> flags & cmdval_visited)) {
+          if (opt -> arg.flags & cmdarg_switch) {
+            val -> value.swc = 0;
+          } else {
+            val -> value.roarg = opt -> arg.defval; // XXX ro
+          }
+          val -> src = &(opt -> arg);
+        }
+      }
+    }
+    if (command -> args) {
+      for (n = 0; command -> args[n].name != NULL; n ++) {
+        const cmdarg_t *arg = command -> args + n;
+        cmdarg_value_t *val = values + arg -> pos;
+        // do not overwrite already specified values
+        if (val -> src == NULL || !(val -> flags & cmdval_visited)) {
+          val -> value.roarg = arg -> defval; // XXX ro
+          val -> src         = arg;
+        }
+      }
+    }
+  }
+
+  // general environment checking
+  if (command -> check) {
+    if ((error = command -> check (command, values))) {
+      gchar *err = error;
+      error = g_strdup_printf("%s: %s", command -> name, err);
+      g_free (err);
+    }
+  }
+
+  // we allow parser to do one extra run on final '\0'
+  while (p <= e && error == NULL) {
+    if (state == in_space) { // space between args/options
+      if (*p == ' ' || p == e) { // still space
+        p ++;
+      } else if (*p == '-' && !opts_ended) { // option
+        state = in_optstart;
+        p ++;
+      } else { // argument
+        if (!option) {
+          opts_ended = TRUE;
+        }
+        s = p;
+        state = in_argstart;
+      }
+    } else if (state == in_optstart) { // long/short option
+      if (*p == ' ' || p == e) { // argument '-'
+        opts_ended = TRUE;
+        s = p = p - 1;
+        state = in_argstart;
+      } else if (*p == '-') { // long option
+        state = in_longoptstart;
+        p ++;
+      } else { // short option
+        s = p;
+        state = in_shortoptend;
+        p ++;
+      }
+    } else if (state == in_shortoptend) { // short option
+      if (*p == ' ' || p == e) { // option really ended
+        size_t n;
+        for (n = 0; command -> opts[n].shortopt != 0; n ++) {
+          if (command -> opts[n].shortopt == *s) {
+            option = command -> opts + n;
+            break;
+          }
+        }
+        if (option != NULL) { // option is known
+          if (option -> arg.flags & cmdarg_switch) { // it is switch
+            cmdarg_value_t *val = values + option -> arg.pos;
+            if (val -> src != &(option -> arg)) {
+              val -> value.swc = 1;
+              val -> src       = &(option -> arg);
+            } else {
+              val -> value.swc ++;
+            }
+            val -> flags |= cmdval_visited;
+            option = NULL;
+          } else if (p == e) {
+            error = g_strdup_printf ("%s: Option -%c needs an argument.", command -> name, option -> shortopt);
+          }
+          state = in_space;
+          p ++;
+        } else { // option is unknown
+          error = g_strdup_printf ("%s: Unknown option -%c.", command -> name, *s);
+        }
+      } else { // short option not ended
+        // consider it argument (to allow -autojoin)
+        opts_ended = TRUE;
+        s = p = p - 2;
+        state = in_argstart;
+      }
+    } else if (state == in_longoptstart) { // long option initialization
+      if (*p == ' ' || p == e) { // end of options '--'
+        opts_ended = TRUE;
+        state = in_space;
+        p ++;
+      } else if (*p == '-') { // argument, starting with '---'
+        opts_ended = TRUE;
+        s = p = p - 2;
+        state = in_argstart;
+      } else { // it is long option
+        s = p;
+        state = in_longopt;
+        p ++;
+      }
+    } else if (state == in_longopt) { // long option name
+      if (*p == ' ' || p == e) { // long option ended
+        size_t n;
+        *p = '\0';
+        for (n = 0; command -> opts[n].shortopt != 0; n ++) {
+          if (!g_strcmp0(command -> opts[n].longopt, s)) {
+            option = command -> opts + n;
+            break;
+          }
+        }
+        if (option != NULL) { // option is known
+          if (option -> arg.flags & cmdarg_switch) { // it is switch
+            cmdarg_value_t *val = values + option -> arg.pos;
+            if (val -> src != &(option -> arg)) {
+              val -> value.swc = 1;
+              val -> src       = &(option -> arg);
+            } else {
+              val -> value.swc ++;
+            }
+            val -> flags |= cmdval_visited;
+            option = NULL;
+          } else if (p == e) {
+            error = g_strdup_printf ("%s: Option --%s needs an argument.", command -> name, option -> longopt);
+          }
+          state = in_space;
+          p ++;
+        } else { // option is unknown
+          error = g_strdup_printf ("%s: Unknown option --%s.", command -> name, option -> longopt);
+        }
+      } else { // still long option
+        p ++;
+      }
+    } else if (state == in_argstart) { // option/command argument initialization
+      const char     *err;
+      const cmdarg_t *arg;
+
+      if (option) { // option argument
+        arg = &(option -> arg);
+      } else if (!command -> args || !command -> args[argno].name) { // no need to parse arguments any further
+        break;
+      } else { // normal aurgument
+        arg = command -> args + argno;
+      }
+
+      if ((err = cmdopts_parse_argument (&p, &e, arg -> flags))) { // get argument value
+        if (!option) {
+          error = g_strdup_printf ("%s: Can't parse argument %s (%lu): %s", command -> name, arg -> name, argno + 1, err);
+        } else if (option -> longopt) {
+          error = g_strdup_printf ("%s: Can't parse argument for option --%s: %s", command -> name, option -> longopt, err);
+        } else {
+          error = g_strdup_printf ("%s: Can't parse argument for option -%c: %s", command -> name, option -> shortopt, err);
+        }
+      } else {
+        cmdarg_value_t *val = values + arg -> pos;
+        val -> value.arg = s;
+        val -> src       = arg;
+        val -> flags    |= cmdval_visited;
+        if (option) { // option argument
+          option = NULL;
+        } else { // normal argument
+          if (arg -> flags & cmdarg_subcmd) { // subcommand
+            const cmdopts_t *subcmd;
+            for (subcmd = command -> cmds; subcmd -> name != NULL; subcmd ++)
+              if (!strcmp (s, subcmd -> name))
+                break;
+            if (subcmd -> name != NULL) { // found subcommand
+              gchar *err;
+              val -> value.cmd = subcmd;
+              if ((err = cmdopts_parse_internal (&p, &e, subcmd, values))) {
+                error = g_strdup_printf("%s %s", command -> name, err);
+                g_free (err);
+              }
+            } else if (arg -> flags & cmdarg_required) { // unknown subcommand
+              error = g_strdup_printf("%s: Unable to find subcommand \"%s\".", command -> name, s);
+            } else { // XXX warning message?
+              val -> value.cmd = NULL;
+            }
+          }
+          argno ++;
+        }
+      }
+      state = in_space;
+    }
+  }
+
+  *pr = p;
+  *er = e;
+
+  return error;
+}
+
+// value types:      type               check                 required
+// - switch          no effect          toboolean()           no effect?
+// - option          check              call checker          fatal check error
+// - argument        check              call checker          fatal check error
+// - subcommand      no effect          check for required    fail if missing
+static gchar *cmdopts_check_values (const cmdopts_t *command, cmdarg_value_t *values)
+{
+  size_t n = command -> valno;
+
+  if (n == 0)
+    return NULL;
+
+  // XXX reverse order?
+  while (n > 0) {
+    cmdarg_value_t *val = values + n - 1;
+    n --;
+    if ((val -> flags & cmdval_visited) || ((val -> src != NULL) && (val -> src -> flags & cmdarg_check))) {
+      if (val -> src -> flags & cmdarg_subcmd) { // subcommand - fail if required and missing
+        if ((val -> src -> flags & cmdarg_required) && (val -> value.cmd == NULL))
+          return g_strdup_printf ("%s: Not specified %s.", command -> name, val -> src -> name);
+      } else if (val -> src -> flags & cmdarg_switch) { // switch - toboolean if check
+        if (val -> src -> flags & cmdarg_check)
+          val -> value.swc %= 2;
+      } else if (val -> src -> type && val -> src -> type -> check) { // typed argument
+        gchar *err;
+        if ((err = val -> src -> type -> check (val))) {
+          // FIXME option name
+          if (val -> src -> flags & cmdarg_required) {
+            gchar *error = g_strdup_printf ("Error in argument value \"%s\": %s", val -> src -> name, err);
+            g_free (err);
+            return error;
+          } else {
+            scr_log_print (LPRINT_NORMAL, "Warning: %s: Error in argument value \"%s\": %s", command -> name, val -> src -> name, err);
+            g_free (err);
+          }
+        }
+      }
+    }
+  }
+
   return NULL;
 }
-#endif
-
-//  cmd_add()
-// Adds a command to the commands list and to the CMD completion list
-gpointer cmd_add(const char *name, const char *help, guint flags_row1,
-                 guint flags_row2, void (*f)(char*), gpointer userdata)
+
+//  cmdopts_free ( commanddef )
+// Free various parser data, used in parsing process
+static void cmdopts_free_values (const cmdopts_t *command, cmdarg_value_t *values)
 {
-  cmd *n_cmd = g_slice_new0(cmd);
-  strncpy(n_cmd->name, name, 32-1);
-  n_cmd->help = help;
-  n_cmd->completion_flags[0] = flags_row1;
-  n_cmd->completion_flags[1] = flags_row2;
-  n_cmd->func = f;
-  n_cmd->userdata = userdata;
-  Commands = g_slist_prepend(Commands, n_cmd);
-  // Add to completion CMD category
-  compl_add_category_word(COMPL_CMD, name);
-  return n_cmd;
+  size_t n = command -> valno;
+
+  if (n == 0)
+    return;
+
+  while (n > 0) {
+    cmdarg_value_t *val = values + n - 1;
+    n --;
+    if ((val -> flags & cmdval_freeme) &&
+        val -> src && val -> src -> type &&
+        val -> src -> type -> free) {
+      val -> src -> type -> free (val);
+    }
+  }
+
+  g_slice_free1 (sizeof(cmdarg_value_t) * n, values);
 }
 
-//  cmd_set_safe(name, safe)
-// Sets if command can be used in startup configuration file.
-gboolean cmd_set_safe(const gchar *name, gboolean safe)
+cmd_result_t cmd_execute (gchar *commandline, cmdexe_flags_t flags)
 {
-  GSList *sel;
-  if (!name)
-    return FALSE;
-  for (sel = safe_commands; sel; sel = sel->next)
-    if (!strcmp((const char *)sel->data, name)) {
-      if (safe)
-        return FALSE;
-      else {
-        g_free(sel->data);
-        safe_commands = g_slist_delete_link(safe_commands, sel);
-      }
+  gchar *s = commandline;
+  gchar *p, *e;
+  gchar *freeme = NULL;
+  const char *err;
+  gchar      *error;
+  cmdopts_t  *command = NULL;
+  const char *alias   = NULL;
+  cmdarg_value_t *values;
+  size_t n;
+
+  // skip command indicator and spaces at the beginning
+  while (*s == COMMAND_CHAR || *s == ' ')
+    s ++;
+  p = s;
+  e = s + strlen (s);
+
+  // separate first word - command name
+  if ((err = cmdopts_parse_argument (&p, &e, cmdarg_default))) {
+    scr_log_print (LPRINT_NORMAL, "error: Can't comprehend command name: %s.", err);
+    return cmd_result_syntax_error;
+  }
+
+  // check for quit command
+  if (!strcmp (s, "quit")) {
+    return cmd_result_quit;
+  }
+
+  // check if we're in verbatim mode
+  if ((flags & cmdexe_check_verbatim) && scr_get_multimode () == 2) {
+    if (strcmp (s, "msay")) { // it is not msay
+      return cmd_result_verbatim;
     }
-  if (safe)
-    safe_commands = g_slist_append(safe_commands, g_strdup(name));
-  else
-    return FALSE;
-  return TRUE;
+  }
+
+  // check and expand alias
+  if ((alias = settings_get (SETTINGS_TYPE_ALIAS, s))) {
+    freeme = s = g_strdup_printf ("%s %s", alias, p);
+    p = s;
+    e = s + strlen (s);
+
+    if ((err = cmdopts_parse_argument (&p, &e, cmdarg_default))) {
+      scr_log_print (LPRINT_NORMAL, "error: Can't comprehend command name: %s.", err);
+      g_free (freeme);
+      return cmd_result_syntax_error;
+    }
+
+    // check for quit command again
+    if (!strcmp (s, "quit")) {
+      g_free (freeme);
+      return cmd_result_quit;
+    }
+  }
+
+  // find command with this name (reverse - see cmd_define())
+  for (n = cmd_count; n > 0; n --) {
+    if (!strcmp (s, cmd_list[n-1] -> name)) {
+      command = cmd_list[n-1];
+      break;
+    }
+  }
+  if (command == NULL) {
+    scr_log_print (LPRINT_NORMAL, "error: Unable to find command \"%s\".", s);
+    g_free (freeme);
+    return cmd_result_not_found;
+  }
+
+  // check safety
+  if ((flags & cmdexe_check_safe) && !(command -> flags & cmd_safe)) {
+    scr_log_print (LPRINT_NORMAL, "error: Command \"%s\" is not safe to execute here.", command -> name);
+    g_free (freeme);
+    return cmd_result_not_found;
+  }
+
+  // allocate dynamic storage for arguments
+  values = cmdopts_allocate_values (command);
+
+  // parse command line
+  if ((error = cmdopts_parse_internal (&p, &e, command, values))) {
+    scr_log_print (LPRINT_NORMAL, "%s", error);
+    g_free (error);
+    cmdopts_free_values (command, values);
+    g_free (freeme);
+    return cmd_result_syntax_error;
+  }
+
+  // do type checking on arguments
+  if ((error = cmdopts_check_values (command, values))) {
+    scr_log_print (LPRINT_NORMAL, "%s: %s", command -> name, error);
+    g_free (error);
+    cmdopts_free_values (command, values);
+    g_free (freeme);
+    return cmd_result_value_error;
+  }
+
+  // execute command handler
+  if (command -> handle) {
+    if ((error = command -> handle (command, values))) {
+      scr_log_print (LPRINT_NORMAL, "%s: %s", command -> name, error);
+      g_free (error);
+      cmdopts_free_values (command, values);
+      g_free (freeme);
+      return cmd_result_runtime_error;
+    }
+  }
+
+  // free resources
+  cmdopts_free_values (command, values);
+  g_free (freeme);
+  return cmd_result_ok;
 }
 
-//  cmd_is_safe(name)
-// Returns if command is safe or not
-gboolean cmd_is_safe(const gchar *name)
+//  process_line(line)
+// Process a command/message line. If this isn't a command, this is a message
+// and it is sent to the currently selected buddy.
+// Returns 255 if the line is the /quit command, 0 on success and some other
+// error codes.
+cmd_result_t process_line(const char *line)
 {
-  GSList *sel;
-  if (!name)
-    return FALSE;
-  for (sel = safe_commands; sel; sel = sel->next)
-    if (!strcmp((const char *)sel->data, name))
-      return TRUE;
-  return FALSE;
-}
-
-//  cmd_init()
-// Commands table initialization
-// !!!
-// After changing commands names and it arguments names here, you must change
-// ones in init_bindings()!
-//
-void cmd_init(void)
-{
-  cmd_add("add", "Add a jabber user", COMPL_JID, 0, &do_add, NULL);
-  cmd_add("alias", "Add an alias", 0, 0, &do_alias, NULL);
-  cmd_add("authorization", "Manage subscription authorizations",
-          COMPL_AUTH, COMPL_JID, &do_authorization, NULL);
-  cmd_add("bind", "Add an key binding", 0, 0, &do_bind, NULL);
-  cmd_add("buffer", "Manipulate current buddy's buffer (chat window)",
-          COMPL_BUFFER, 0, &do_buffer, NULL);
-  cmd_add("chat_disable", "Disable chat mode", 0, 0, &do_chat_disable, NULL);
-  cmd_add("clear", "Clear the dialog window", 0, 0, &do_clear, NULL);
-  cmd_add("color", "Set coloring options", COMPL_COLOR, 0, &do_color, NULL);
-  cmd_add("connect", "Connect to the server", 0, 0, &do_connect, NULL);
-  cmd_add("del", "Delete the current buddy", 0, 0, &do_del, NULL);
-  cmd_add("disconnect", "Disconnect from server", 0, 0, &do_disconnect, NULL);
-  cmd_add("echo", "Display a string in the log window", 0, 0, &do_echo, NULL);
-  cmd_add("event", "Process an event", COMPL_EVENTSID, COMPL_EVENTS, &do_event,
-          NULL);
-  cmd_add("exit",  "Exit mcabber", 0, 0, &do_exit, NULL);
-  cmd_add("group", "Change group display settings",
-          COMPL_GROUP, COMPL_GROUPNAME, &do_group, NULL);
-  cmd_add("help", "Display some help", COMPL_CMD, 0, &do_help, NULL);
-  cmd_add("iline", "Manipulate input buffer", 0, 0, &do_iline, NULL);
-  cmd_add("info", "Show basic info on current buddy", 0, 0, &do_info, NULL);
-  cmd_add("module", "Manipulations with modules", COMPL_MODULE, 0, &do_module,
-          NULL);
-  cmd_add("move", "Move the current buddy to another group", COMPL_GROUPNAME,
-          0, &do_move, NULL);
-  cmd_add("msay", "Send a multi-lines message to the selected buddy",
-          COMPL_MULTILINE, 0, &do_msay, NULL);
-  cmd_add("otr", "Manage OTR settings", COMPL_OTR, COMPL_JID, &do_otr, NULL);
-  cmd_add("otrpolicy", "Manage OTR policies", COMPL_JID, COMPL_OTRPOLICY,
-          &do_otrpolicy, NULL);
-  cmd_add("pgp", "Manage PGP settings", COMPL_PGP, COMPL_JID, &do_pgp, NULL);
-  cmd_add("quit", "Exit the software", 0, 0, NULL, NULL);
-  cmd_add("rawxml", "Send a raw XML string", 0, 0, &do_rawxml, NULL);
-  cmd_add("rename", "Rename the current buddy", 0, 0, &do_rename, NULL);
-  cmd_add("request", "Send a Jabber IQ request", COMPL_REQUEST, COMPL_JID,
-          &do_request, NULL);
-  cmd_add("room", "MUC actions command", COMPL_ROOM, 0, &do_room, NULL);
-  cmd_add("roster", "Manipulate the roster/buddylist", COMPL_ROSTER, 0,
-          &do_roster, NULL);
-  cmd_add("say", "Say something to the selected buddy", 0, 0, &do_say, NULL);
-  cmd_add("say_to", "Say something to a specific buddy", COMPL_JID, 0,
-          &do_say_to, NULL);
-  cmd_add("screen_refresh", "Redraw mcabber screen", 0, 0, &do_screen_refresh,
-          NULL);
-  cmd_add("set", "Set/query an option value", 0, 0, &do_set, NULL);
-  cmd_add("source", "Read a configuration file", 0, 0, &do_source, NULL);
-  cmd_add("status", "Show or set your status", COMPL_STATUS, 0, &do_status,
-          NULL);
-  cmd_add("status_to", "Show or set your status for one recipient",
-          COMPL_JID, COMPL_STATUS, &do_status_to, NULL);
-  cmd_add("version", "Show mcabber version", 0, 0, &do_version, NULL);
-
-  cmd_set_safe("set", TRUE);
-  cmd_set_safe("bind", TRUE);
-  cmd_set_safe("alias", TRUE);
-  cmd_set_safe("pgp", TRUE);
-  cmd_set_safe("source", TRUE);
-  cmd_set_safe("status", TRUE);
-  cmd_set_safe("color", TRUE);
-  cmd_set_safe("otrpolicy", TRUE);
-  cmd_set_safe("module", TRUE);
-
-  // Status category
-  compl_add_category_word(COMPL_STATUS, "online");
-  compl_add_category_word(COMPL_STATUS, "avail");
-#ifdef WITH_DEPRECATED_STATUS_INVISIBLE
-  compl_add_category_word(COMPL_STATUS, "invisible");
-#endif
-  compl_add_category_word(COMPL_STATUS, "free");
-  compl_add_category_word(COMPL_STATUS, "dnd");
-  compl_add_category_word(COMPL_STATUS, "notavail");
-  compl_add_category_word(COMPL_STATUS, "away");
-  compl_add_category_word(COMPL_STATUS, "offline");
-  compl_add_category_word(COMPL_STATUS, "message");
-
-  // Roster category
-  compl_add_category_word(COMPL_ROSTER, "bottom");
-  compl_add_category_word(COMPL_ROSTER, "top");
-  compl_add_category_word(COMPL_ROSTER, "up");
-  compl_add_category_word(COMPL_ROSTER, "down");
-  compl_add_category_word(COMPL_ROSTER, "group_prev");
-  compl_add_category_word(COMPL_ROSTER, "group_next");
-  compl_add_category_word(COMPL_ROSTER, "hide");
-  compl_add_category_word(COMPL_ROSTER, "show");
-  compl_add_category_word(COMPL_ROSTER, "toggle");
-  compl_add_category_word(COMPL_ROSTER, "display");
-  compl_add_category_word(COMPL_ROSTER, "hide_offline");
-  compl_add_category_word(COMPL_ROSTER, "show_offline");
-  compl_add_category_word(COMPL_ROSTER, "toggle_offline");
-  compl_add_category_word(COMPL_ROSTER, "item_lock");
-  compl_add_category_word(COMPL_ROSTER, "item_unlock");
-  compl_add_category_word(COMPL_ROSTER, "item_toggle_lock");
-  compl_add_category_word(COMPL_ROSTER, "alternate");
-  compl_add_category_word(COMPL_ROSTER, "search");
-  compl_add_category_word(COMPL_ROSTER, "unread_first");
-  compl_add_category_word(COMPL_ROSTER, "unread_next");
-  compl_add_category_word(COMPL_ROSTER, "note");
-  compl_add_category_word(COMPL_ROSTER, "resource_lock");
-  compl_add_category_word(COMPL_ROSTER, "resource_unlock");
-
-  // Buffer category
-  compl_add_category_word(COMPL_BUFFER, "clear");
-  compl_add_category_word(COMPL_BUFFER, "bottom");
-  compl_add_category_word(COMPL_BUFFER, "top");
-  compl_add_category_word(COMPL_BUFFER, "up");
-  compl_add_category_word(COMPL_BUFFER, "down");
-  compl_add_category_word(COMPL_BUFFER, "search_backward");
-  compl_add_category_word(COMPL_BUFFER, "search_forward");
-  compl_add_category_word(COMPL_BUFFER, "readmark");
-  compl_add_category_word(COMPL_BUFFER, "date");
-  compl_add_category_word(COMPL_BUFFER, "%");
-  compl_add_category_word(COMPL_BUFFER, "purge");
-  compl_add_category_word(COMPL_BUFFER, "close");
-  compl_add_category_word(COMPL_BUFFER, "close_all");
-  compl_add_category_word(COMPL_BUFFER, "scroll_lock");
-  compl_add_category_word(COMPL_BUFFER, "scroll_unlock");
-  compl_add_category_word(COMPL_BUFFER, "scroll_toggle");
-  compl_add_category_word(COMPL_BUFFER, "list");
-  compl_add_category_word(COMPL_BUFFER, "save");
-
-  // Group category
-  compl_add_category_word(COMPL_GROUP, "fold");
-  compl_add_category_word(COMPL_GROUP, "unfold");
-  compl_add_category_word(COMPL_GROUP, "toggle");
-
-  // Multi-line (msay) category
-  compl_add_category_word(COMPL_MULTILINE, "abort");
-  compl_add_category_word(COMPL_MULTILINE, "begin");
-  compl_add_category_word(COMPL_MULTILINE, "send");
-  compl_add_category_word(COMPL_MULTILINE, "send_to");
-  compl_add_category_word(COMPL_MULTILINE, "toggle");
-  compl_add_category_word(COMPL_MULTILINE, "toggle_verbatim");
-  compl_add_category_word(COMPL_MULTILINE, "verbatim");
-
-  // Room category
-  compl_add_category_word(COMPL_ROOM, "affil");
-  compl_add_category_word(COMPL_ROOM, "ban");
-  compl_add_category_word(COMPL_ROOM, "bookmark");
-  compl_add_category_word(COMPL_ROOM, "destroy");
-  compl_add_category_word(COMPL_ROOM, "invite");
-  compl_add_category_word(COMPL_ROOM, "join");
-  compl_add_category_word(COMPL_ROOM, "kick");
-  compl_add_category_word(COMPL_ROOM, "leave");
-  compl_add_category_word(COMPL_ROOM, "names");
-  compl_add_category_word(COMPL_ROOM, "nick");
-  compl_add_category_word(COMPL_ROOM, "privmsg");
-  compl_add_category_word(COMPL_ROOM, "remove");
-  compl_add_category_word(COMPL_ROOM, "role");
-  compl_add_category_word(COMPL_ROOM, "setopt");
-  compl_add_category_word(COMPL_ROOM, "topic");
-  compl_add_category_word(COMPL_ROOM, "unban");
-  compl_add_category_word(COMPL_ROOM, "unlock");
-  compl_add_category_word(COMPL_ROOM, "whois");
-
-  // Authorization category
-  compl_add_category_word(COMPL_AUTH, "allow");
-  compl_add_category_word(COMPL_AUTH, "cancel");
-  compl_add_category_word(COMPL_AUTH, "request");
-  compl_add_category_word(COMPL_AUTH, "request_unsubscribe");
-
-  // Request (query) category
-  compl_add_category_word(COMPL_REQUEST, "last");
-  compl_add_category_word(COMPL_REQUEST, "ping");
-  compl_add_category_word(COMPL_REQUEST, "time");
-  compl_add_category_word(COMPL_REQUEST, "vcard");
-  compl_add_category_word(COMPL_REQUEST, "version");
-
-  // Events category
-  compl_add_category_word(COMPL_EVENTS, "accept");
-  compl_add_category_word(COMPL_EVENTS, "ignore");
-  compl_add_category_word(COMPL_EVENTS, "reject");
-
-  // PGP category
-  compl_add_category_word(COMPL_PGP, "disable");
-  compl_add_category_word(COMPL_PGP, "enable");
-  compl_add_category_word(COMPL_PGP, "force");
-  compl_add_category_word(COMPL_PGP, "info");
-  compl_add_category_word(COMPL_PGP, "setkey");
-
-  // OTR category
-  compl_add_category_word(COMPL_OTR, "start");
-  compl_add_category_word(COMPL_OTR, "stop");
-  compl_add_category_word(COMPL_OTR, "fingerprint");
-  compl_add_category_word(COMPL_OTR, "smpq");
-  compl_add_category_word(COMPL_OTR, "smpr");
-  compl_add_category_word(COMPL_OTR, "smpa");
-  compl_add_category_word(COMPL_OTR, "info");
-  compl_add_category_word(COMPL_OTR, "key");
-
-  // OTR Policy category
-  compl_add_category_word(COMPL_OTRPOLICY, "plain");
-  compl_add_category_word(COMPL_OTRPOLICY, "manual");
-  compl_add_category_word(COMPL_OTRPOLICY, "opportunistic");
-  compl_add_category_word(COMPL_OTRPOLICY, "always");
-
-  // Color category
-  compl_add_category_word(COMPL_COLOR, "roster");
-  compl_add_category_word(COMPL_COLOR, "muc");
-  compl_add_category_word(COMPL_COLOR, "mucnick");
-
-#ifdef MODULES_ENABLE
-  // Module category
-  compl_add_category_word(COMPL_MODULE, "info");
-  compl_add_category_word(COMPL_MODULE, "list");
-  compl_add_category_word(COMPL_MODULE, "load");
-  compl_add_category_word(COMPL_MODULE, "unload");
-#endif
-}
-
-//  expandalias(line)
-// If there is one, expand the alias in line and returns a new allocated line
-// If no alias is found, returns line
-// Note: if the returned pointer is different from line, the caller should
-//       g_free() the pointer after use
-char *expandalias(const char *line)
-{
-  const char *p1, *p2;
-  char *word;
-  const gchar *value;
-  char *newline = (char*)line;
-
-  // Ignore leading COMMAND_CHAR
-  for (p1 = line ; *p1 == COMMAND_CHAR ; p1++)
-    ;
-  // Locate the end of the word
-  for (p2 = p1 ; *p2 && (*p2 != ' ') ; p2++)
-    ;
-  // Extract the word and look for an alias in the list
-  word = g_strndup(p1, p2-p1);
-  value = settings_get(SETTINGS_TYPE_ALIAS, (const char*)word);
-  g_free(word);
-
-  if (value)
-    newline = g_strdup_printf("%c%s%s", COMMAND_CHAR, value, p2);
-
-  return newline;
-}
-
-//  cmd_get
-// Finds command in the command list structure.
-// Returns a pointer to the cmd entry, or NULL if command not found.
-cmd *cmd_get(const char *command)
-{
-  const char *p1, *p2;
-  char *com;
-  GSList *sl_com;
-
-  // Ignore leading COMMAND_CHAR
-  for (p1 = command ; *p1 == COMMAND_CHAR ; p1++)
-    ;
-  // Locate the end of the command
-  for (p2 = p1 ; *p2 && (*p2 != ' ') ; p2++)
-    ;
-  // Copy the clean command
-  com = g_strndup(p1, p2-p1);
-
-  // Look for command in the list
-  for (sl_com=Commands; sl_com; sl_com = g_slist_next(sl_com)) {
-    if (!strcasecmp(com, ((cmd*)sl_com->data)->name))
-      break;
-  }
-  g_free(com);
-
-  if (sl_com)       // Command has been found.
-    return (cmd*)sl_com->data;
-  return NULL;
-}
-
-//  process_command(line, iscmd)
-// Process a command line.
-// If iscmd is TRUE, process the command even if verbatim mmode is set;
-// it is intended to be used for key bindings.
-// Return 255 if this is the /quit command, and 0 for the other commands.
-int process_command(const char *line, guint iscmd)
-{
-  char *p;
-  char *xpline;
-  cmd *curcmd;
-
-  if (!line)
-    return 0;
-
-  // We do alias expansion here
-  if (iscmd || scr_get_multimode() != 2)
-    xpline = expandalias(line);
-  else
-    xpline = (char*)line; // No expansion in verbatim multi-line mode
-
-  // We want to use a copy
-  if (xpline == line)
-    xpline = g_strdup(line);
-
-  // Remove trailing spaces:
-  for (p=xpline ; *p ; p++)
-    ;
-  for (p-- ; p>xpline && (*p == ' ') ; p--)
-    *p = 0;
-
-  // Command "quit"?
-  if ((iscmd || scr_get_multimode() != 2)
-      && (!strncasecmp(xpline, mkcmdstr("quit"), strlen(mkcmdstr("quit"))))) {
-    if (!xpline[5] || xpline[5] == ' ') {
-      g_free(xpline);
-      return 255;
-    }
-  } else if (iscmd && !strncasecmp(xpline, "quit", 4) &&
-             (!xpline[4] || xpline[4] == ' ')) {
-    // If iscmd is true we can have the command without the command prefix
-    // character (usually '/').
-    g_free(xpline);
-    return 255;
-  }
-
-  // If verbatim multi-line mode, we check if another /msay command is typed
-  if (!iscmd && scr_get_multimode() == 2
-      && (strncasecmp(xpline, mkcmdstr("msay "), strlen(mkcmdstr("msay "))))) {
-    // It isn't an /msay command
-    scr_append_multiline(xpline);
-    g_free(xpline);
-    return 0;
-  }
-
-  // Commands handling
-  curcmd = cmd_get(xpline);
-
-  if (!curcmd) {
-    scr_LogPrint(LPRINT_NORMAL, "Unrecognized command.  "
-                 "Please see the manual for a list of known commands.");
-    g_free(xpline);
-    return 0;
-  }
-  if (!curcmd->func) {
-    scr_LogPrint(LPRINT_NORMAL,
-                 "This functionality is not yet implemented, sorry.");
-    g_free(xpline);
-    return 0;
-  }
-  // Lets go to the command parameters
-  for (p = xpline+1; *p && (*p != ' ') ; p++)
-    ;
-  // Skip spaces
-  while (*p && (*p == ' '))
-    p++;
-  // Call command-specific function
-  retval_for_cmds = 0;
-#ifdef MODULES_ENABLE
-  if (curcmd->userdata)
-    (*(void (*)(char *p, gpointer u))curcmd->func)(p, curcmd->userdata);
-  else
-    (*curcmd->func)(p);
-#else
-  (*curcmd->func)(p);
-#endif
-  g_free(xpline);
-  return retval_for_cmds;
-}
-
-//  process_line(line)
-// Process a command/message line.
-// If this isn't a command, this is a message and it is sent to the
-// currently selected buddy.
-// Return 255 if the line is the /quit command, or 0.
-int process_line(const char *line)
-{
+  gchar *utf8;
+  int retval;
+
   if (!*line) { // User only pressed enter
     if (scr_get_multimode()) {
       scr_append_multiline("");
